//////////////////////////////////////////////////////////////////
//
//    FreeLing - Open Source Language Analyzers
//
//    Copyright (C) 2004   TALP Research Center
//                         Universitat Politecnica de Catalunya
//
//    This library is free software; you can redistribute it and/or
//    modify it under the terms of the GNU Lesser General Public
//    License as published by the Free Software Foundation; either
//    version 2.1 of the License, or (at your option) any later version.
//
//    This library is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//    Lesser General Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public
//    License along with this library; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//
//    contact: Lluis Padro (padro@lsi.upc.es)
//             TALP Research Center
//             despatx C6.212 - Campus Nord UPC
//             08034 Barcelona.  SPAIN
//
////////////////////////////////////////////////////////////////


#ifndef _LOCUTIONS
#define _LOCUTIONS

#include <map> 
#include <set> 

#include "maco_options.h"
#include "language.h"
#include "automat.h"

////////////////////////////////////////////////////////////////
/// Class locutions recognizes multiwords belonging to 
/// a list obtained from a  configuration file.
////////////////////////////////////////////////////////////////

class locutions: public automat {
   private:
      /// store multiword list
      map<string,string> locut;
      /// store multiword prefixes
      set<string> prefixes;
      /// partially build multiword.
      list<string> acc_mw,longest_mw;
      /// store mw components in case we need to recover them
      vector<word> components;

      void check(const string, list<string> &, bool &, bool &);
      int ComputeToken(int, sentence::const_iterator, const sentence &);
      void ResetActions();
      void StateActions(int, int, int, sentence::const_iterator);
      void SetMultiwordAnalysis(sentence::iterator) const;

   public:
      /// Constructor
      locutions(const maco_options &);
};

#endif

