//////////////////////////////////////////////////////////////////
//
//    FreeLing - Open Source Language Analyzers
//
//    Copyright (C) 2004   TALP Research Center
//                         Universitat Politecnica de Catalunya
//
//    This library is free software; you can redistribute it and/or
//    modify it under the terms of the GNU Lesser General Public
//    License as published by the Free Software Foundation; either
//    version 2.1 of the License, or (at your option) any later version.
//
//    This library is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//    Lesser General Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public
//    License along with this library; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//
//    contact: Lluis Padro (padro@lsi.upc.es)
//             TALP Research Center
//             despatx C6.212 - Campus Nord UPC
//             08034 Barcelona.  SPAIN
//
////////////////////////////////////////////////////////////////

#ifndef _UTIL
#define _UTIL

#include <list>
#include <string>

using namespace std;

////////////////////////////////////////////////////////////////
///  Class util implements some utilities for NLP analyzers:
///  "tolower" for latin alfabets, parole tags manipulation,
///  string2number and viceversa conversions, etc.
/////////////////////////////////////////////////////////////

class util {
 public:
   /// Lowercase a string, even with latin characters
   static string lowercase(const string &);
   /// find out whether a char is alphanumeric, even latin caracters 
   static bool isalphanum(const char);
   /// find out whether a string contains a lowercase char, even latin caracters 
   static bool has_lowercase(const string &);
   /// conversion utilities
   static int string2int(const string &);
   static string int2string(const int);
   static double string2double(const string &);
   static string double2string(const double);
   static long double string2longdouble(const string &);
   static string longdouble2string(const long double);
   static string list2string(const list<string> &, const char);
   static list<string> string2list(const string &, const char);
};

#endif
